#include "ptoc.h"



  /* by Joseph Bergin, Sept. 1989.
    A docoder for the SAM2 output files.*/

typedef signed char byterange;
const int min_byterange = -128;
const int max_byterange = 127;

typedef set_template<8> byte1;
/*
struct bcrec {
          union {
            byterange bytef;
            byte1 hintf;
          };
};
*/

typedef union bcrec {
   byte1 hintf; //4 bytes
   struct pad {
    byterange p3, p2, p1; //1 byte each
   	byterange bytef; // 1 byte
  } pad;
} bcrec;


integer n,  /*byte number*/
y,  /*for the raw high byte*/
xx, /*x as an integer with adjustments*/
zz, /*z as an integer*/
xi, /*x as an integer*/
i,  /*the FOR loop counter*/
f   /*the high bit of the low byte. Bit 7*/;

byterange x,z;   /*input data*/
file<byterange> infile;
text outfile;
bcrec movex,movez;        /*input data as bits*/

int main(int argc, const char* argv[])
{
     /*open(infile,'OBJ');*/
     /*open(outfile,'MEM');*/
     pio_initialize(argc, argv);
     reset(infile, "OBJ");
     rewrite(outfile, "MEM.txt");
     n = 0;
     outfile << " num   binary" << format(" opcode:15-11",20) << "  reg:10-7" << 
                         "   6-4  3-0  " << format(" raw Hi",10) << "  raw Lo" << NL;
     while (! eof(infile))  {
           infile >> x >> z;
           movex.pad.bytef = x;
           movez.pad.bytef = z;
           y = x;
           if (y < 0)  y = 256+y;
           xx = x+128; if (xx == 128)  xx = 0;
           zz = z;
           if (z < 0)  zz = zz + 256;
           xi = x;
           if (z<0)  f = 1; else f = 0;
           outfile << format(n,5) << ' '/*,x:6,z:6, xx:10,zz:6*/;
           for( i = 7; i >= 0; i --)
               if (movex.hintf.has(i))  outfile << format(1,1);
                                   else outfile << format(0,1);
           for( i = 7; i >= 0; i --)
               if (movez.hintf.has(i))  outfile << format(1,1);
                                   else outfile << format(0,1);
           outfile << ' ';
           if (x>=0) 
             outfile <<  format(xi / 8,6) << format(xi % 8*2+f,10);
           else
             outfile <<  format(16+xx / 8,6) << format(xx % 8*2+f,10);
           outfile << format(zz / 16,10) << format(zz % 16,5) << format(y,10) << format(zz,6) << NL;

           n = n+2;
           }
     close(outfile);
     return EXIT_SUCCESS;
}
