PROGRAM transl;

  { by Joseph Bergin, Sept. 1989.}
{    A docoder for the SAM2 output files.}

	TYPE
		byterange = -128..127;
		byte = SET OF 0..7;
		bcrec = RECORD
				CASE boolean OF
					true: (
							bytef: byterange
					);
					false: (
							hintf: byte
					);
			END;

	VAR
		n,  {byte number}
		y,  {for the raw high byte}
		xx, {x as an integer with adjustments}
		zz, {z as an integer}
		xi, {x as an integer}
		i,  {the FOR loop counter}
		f:  {the high bit of the low byte. Bit 7}
		integer;

		x, z: byterange;  {input data}
		infile: FILE OF byterange;
		outfile: text;
		movex, movez: bcrec;  {input data as bits}

BEGIN
reset(infile, 'OBJ');
rewrite(outfile, 'MEM');
n := 0;
writeln(outfile, ' num   binary', ' opcode:15-11' : 20, '  reg:10-7', '   6-4  3-0  ', ' raw Hi' : 10, '  raw Lo');
WHILE NOT eof(infile) DO BEGIN
	read(infile, x, z);
	movex.bytef := x;
	movez.bytef := z;
	y := x;
	IF y < 0 THEN
		y := 256 + y;
	xx := x + 128;
	IF xx = 128 THEN
		xx := 0;
	zz := z;
	IF z < 0 THEN
		zz := zz + 256;
	IF z > 0 THEN
		zz := z;
	xi := x;
	IF (z < 0) THEN
		f := 1
	ELSE
		f := 0;
	write(outfile, n : 5, ' '); {,x:6,z:6, xx:10,zz:6}
	FOR i := 7 DOWNTO 0 DO
		IF i IN movex.hintf THEN
			write(outfile, 1 : 1)
		ELSE
			write(outfile, 0 : 1);
	FOR i := 7 DOWNTO 0 DO
		IF i IN movez.hintf THEN
			write(outfile, 1 : 1)
		ELSE
			write(outfile, 0 : 1);
	write(outfile, ' ');
	IF x >= 0 THEN
		write(outfile, xi DIV 8 : 6, xi MOD 8 * 2 + f : 10)
	ELSE
		write(outfile, 16 + xx DIV 8 : 6, xx MOD 8 * 2 + f : 10);
	writeln(outfile, zz DIV 16 : 10, zz MOD 16 : 5, y : 10, zz : 6);

	n := n + 2;
	END;
close(outfile);
END.